=== debian/changelog ===
sdbus-cpp (2.0.0-2) unstable; urgency=medium

  * Upload to unstable
  * Bump Standards-Version to 4.7.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 31 Oct 2024 17:31:33 +0800

sdbus-cpp (2.0.0-1) experimental; urgency=medium

  * New upstream release (Closes: #1085735)
  * Bump SO version to 2

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 28 Oct 2024 22:45:30 +0800
