=== debian/changelog ===
sdbus-cpp (2.1.0-1) unstable; urgency=medium

  * New upstream release
  * Replace pkg-config with pkgconf in Build-Depends

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 30 Nov 2024 04:36:23 +0800
