=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libexpat1-dev,
  libgmock-dev (>= 1.10.0~) <!nocheck>,
  libsystemd-dev,
- pkg-config,
+ pkgconf,
 Build-Depends-Indep:
  doxygen <!nodoc>,
 Standards-Version: 4.7.0
