=== debian/rules ===
--- 
+++ 
@@ -29,7 +29,7 @@
 	-rm -v /tmp/dbus.conf /tmp/sdbuscpp_bus /tmp/sdbuscpp.pid
 
 override_dh_auto_configure-indep:
-	dh_auto_configure -- -DSDBUSCPP_BUILD_DOCS=ON -DBUILD_DOXYGEN_DOC=ON
+	dh_auto_configure -- -DSDBUSCPP_BUILD_DOCS=ON -DSDBUSCPP_BUILD_DOXYGEN_DOCS=ON
 
 override_dh_auto_build-indep:
 	dh_auto_build -- doc
