## sdbus-cpp 2.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 cmake_minimum_required(VERSION 3.14)
 
-project(sdbus-c++ VERSION 2.0.0 LANGUAGES CXX C)
+project(sdbus-c++ VERSION 2.2.1 LANGUAGES CXX C)
 
 include(GNUInstallDirs) # Installation directories for `install` command and pkgconfig file
 
@@ -17,7 +17,7 @@
     set(SDBUSCPP_SDBUS_LIB "default" CACHE STRING "sd-bus implementation library to search for and use (default, systemd, elogind, or basu)")
     set_property(CACHE SDBUSCPP_SDBUS_LIB PROPERTY STRINGS default systemd elogind basu)
 else()
-    set(SDBUSCPP_LIBSYSTEMD_VERSION "242" CACHE STRING "libsystemd version (>=239) to build and incorporate into libsdbus-c++")
+    set(SDBUSCPP_LIBSYSTEMD_VERSION "252" CACHE STRING "libsystemd version (>=239) to build and incorporate into libsdbus-c++")
     set(SDBUSCPP_LIBSYSTEMD_EXTRA_CONFIG_OPTS "" CACHE STRING "Additional configuration options to be passed as-is to libsystemd build system")
 endif()
 option(SDBUSCPP_INSTALL "Enable installation of sdbus-c++ (downstream projects embedding sdbus-c++ may want to turn this OFF)" ON)
@@ -26,7 +26,7 @@
     option(SDBUSCPP_BUILD_PERF_TESTS "Build also sdbus-c++ performance tests" OFF)
     option(SDBUSCPP_BUILD_STRESS_TESTS "Build also sdbus-c++ stress tests" OFF)
     set(SDBUSCPP_TESTS_INSTALL_PATH "tests/${PROJECT_NAME}" CACHE STRING "Specifies where the test binaries will be installed")
-    set(SDBUSCPP_GOOGLETEST_VERSION 1.10.0 CACHE STRING "Version of gmock library to use")
+    set(SDBUSCPP_GOOGLETEST_VERSION 1.14.0 CACHE STRING "Version of gmock library to use")
     set(SDBUSCPP_GOOGLETEST_GIT_REPO "https://github.com/google/googletest.git" CACHE STRING "A git repo to clone and build googletest from if gmock is not found in the system")
 endif()
 option(SDBUSCPP_BUILD_CODEGEN "Build generator tool for C++ native bindings" OFF)
@@ -86,17 +86,19 @@
         set(SDBUS_LIBS systemd elogind basu) # This is the default search order
     endif()
 
+    set(MINIMUM_SDBUS_VERSION 238)
+
     find_package(PkgConfig REQUIRED)
     foreach(LIB ${SDBUS_LIBS})
         if(LIB STREQUAL "systemd")
-            pkg_check_modules(Systemd IMPORTED_TARGET GLOBAL libsystemd>=238)
+            pkg_check_modules(Systemd IMPORTED_TARGET GLOBAL libsystemd>=${MINIMUM_SDBUS_VERSION})
             if(TARGET PkgConfig::Systemd)
                 set(SDBUS_IMPL "systemd")
                 set(SDBUS_LIB "libsystemd")
                 break()
             endif()
         elseif(LIB STREQUAL "elogind")
-            pkg_check_modules(Systemd IMPORTED_TARGET GLOBAL libelogind>=238)
+            pkg_check_modules(Systemd IMPORTED_TARGET GLOBAL libelogind>=${MINIMUM_SDBUS_VERSION})
             if(TARGET PkgConfig::Systemd)
                 set(SDBUS_IMPL "elogind")
                 set(SDBUS_LIB "libelogind")
@@ -285,5 +287,3 @@
 if(SDBUSCPP_INSTALL)
     set(EXPORT_SET sdbus-c++)
     if(NOT BUILD_SHARED_LIBS)
-        list(APPEND EXPORT_SET "sdbus-c++-objlib")
-    endif()
