=== debian/changelog ===
sdbus-cpp (2.2.1-1) unstable; urgency=medium

  * New upstream release
    + Fix invalid code generation by sdbus-c++-xml2cpp (Closes: #1113921)
  * Bump Standards-Version to 4.7.3 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 23 Jan 2026 02:43:45 +0800
