=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  pkgconf,
 Build-Depends-Indep:
  doxygen <!nodoc>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://github.com/Kistler-Group/sdbus-cpp
 Vcs-Git: https://salsa.debian.org/zhsj/sdbus-cpp.git
 Vcs-Browser: https://salsa.debian.org/zhsj/sdbus-cpp
